﻿using Infragistics;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfPartialAutoGenFields
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			var vm = new SampleViewModel();
			var items = new ObservableCollection<InfoModel>();

			items.Add(new InfoModel
			{
				StudentNAME = "A",
				Age = 25,
				ID = 1,
				BooksIssued = new ObservableCollection<BookModel>(new[] 
				{ 
					new BookModel { Title = "ABC", Author = "ABC Author" },
					new BookModel { Title = "XYZ", Author = "XYZ Author" }
				})
			});

			items.Add(new InfoModel
			{
				StudentNAME = "B",
				Age = 31,
				ID = 2,
				BooksIssued = new ObservableCollection<BookModel>(new[] 
				{ 
					new BookModel { Title = "QWERTY", Author = "Unknown" },
					new BookModel { Title = "Deers", Author = "John Doe" }
				})
			});

			vm.Informations = items;
			this.DataContext = vm;

			InitializeComponent();
		}
	}

		

	public class SampleViewModel
	{
		public IEnumerable<InfoModel> Informations{get;set;} // This is the data source for XAMData grid
	}

	public class InfoModel : PropertyChangeNotifierExtended
	{
		//All properties here
		private String _studentName;
		public String StudentNAME // ( Need to be shown)
		{
			get { return _studentName; }
			set { this.SetField(ref _studentName, value, "StudentNAME"); }
		}

		private IEnumerable _booksIssued;
		public IEnumerable BooksIssued // (  Need to be shown, I don't know the Column as its dynamic)
		{
			get { return _booksIssued; }
			set { this.SetField(ref _booksIssued, value, "BooksIssued"); }
		}

		//Some more additonal fields which i dont want on GUI
		private int _id;
		public int ID // (Should not be displayed on GUI)
		{
			get { return _id; }
			set { this.SetField(ref _id, value, "ID"); }
		}

		private int _age;
		public int Age //(Should not be displayed on GUI)
		{
			get { return _age; }
			set { this.SetField(ref _age, value, "Age"); }
		}
	}

	public class BookModel : PropertyChangeNotifierExtended
	{
		public string _title;
		public string Title 
		{
			get { return _title; }
			set { this.SetField(ref _title, value, "Title"); }
		}

		public string _author;
		public string Author 
		{
			get { return _author; }
			set { this.SetField(ref _author, value, "Author"); }
		}
	}
}
